'-------------------------------------------------------------------------------
'              Program sterujcy wycigiem
'             sygna wyjciowy!!! (sterownik przyciski-panel testowy)
'
'                                                       4.04.2011
' 
'
'  modyfikacja: obliczanie rnicy miedzy temperaturami  22.05.2011
'-------------------------------------------------------------------------------

$regfile = "m8def.DAT"                                      'deklaracja procesora, w tym wypadku Atmega8
$crystal = 1000000                                          'deklaracja czetotlwioci pracy (wew oscylator 1MHz w zupenoci wystarcza)

Config Portb = &B11111111                                   '[B7---B0] 0=wejscie 1=wyjscie
        Portb = &B00000000                                  '  1=5V  0=0V podcigniecie lub bez

Config Portd = &B11111111                                   '[D7---D0] 0 - wejcia, 1 - wyjcia
        Portd = &B00000000                                  ' 1=5V  0=0V podcigniecie lub bez

Config Portc = &B110000                                     '[C5---C0] 0=wejscie, 1=wyjscie    C0,C1,C2,C3-wejscie
        Portc = &B001111                                    ' 1=5V  0=0V podcigniecie lub bez


'Deklaracja portw od wywietlacza LCD
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portb.7 , Db6 = Portd.5 , Db7 = Portb.6 , E = Portd.3 , Rs = Portd.2


Config Lcd = 16 * 2                                         'ustawiamy typ wywietlacza



Config 1wire = Portb.1                                      'deklaracja portu na ktrym bd podpite DS18b20

Dim I1 As Integer , Ss As String * 6
Dim I2 As Integer


Dim Dsid1(8) As Byte
Dim Dsid2(8) As Byte

Dim B As Byte                                               'deklaracja zmiennej do odczytu kodw ID
Dim W As Byte                                               'deklaracja zmiennej do odczytu iloc czujnikw

Dim R As Byte                                               'deklaracja zmiennej do odczytu runicy tem.


Dim A As Single                                             ' zmienna do okrelenia "biegw"
Dim Bb As Single                                            ' zmienna do okrelenia stanu "owietlenie"
Dim C As Single                                             ' zmienne do sumowania "bieg" i "owietlenie"
Dim Cc As Single                                            ' zmienna do okrelenia stanu "Auto"
Dim D As Single                                             ' zmienna do

Dim E As Single                                             'zmienna liczca ilo wykonanej ptli gwnej

Portb.0 = 1                                                 'port wysyania komdy na ukad przekanikw
'---------------------------------------------------------------------


Cls
W = 1wirecount()
                                     'Informuje ile czujnikw jest podpitych do ukadu (pojawia si tylko podczas wczania urzdzenia)

                                                       'Znajd pierwszy czujnik podpity do portu
Dsid1(1) = 1wsearchfirst()                                  'Znajd kolejny czujnik podpity do portu
Dsid2(1) = 1wsearchnext()                                   'Znajd kolejny czujnik podpity do portu


'*******************Odczyt numerw ID czujnikw temperatury*********************

If Dsid1(8) = Crc8(dsid1(1) , 7) Then                       'ta opcja pojawia si tylko przy wczaniu urzdzenia
 Locate 1 , 1

 Wait 1
 Locate 1 , 1
 For B = 1 To 8
 Lcd Hex(dsid1(b))
 Next
End If
Wait 1

If Dsid2(8) = Crc8(dsid2(1) , 7) Then
 Locate 2 , 1

 Wait 1
 Locate 2 , 1
 For B = 1 To 8
 Lcd Hex(dsid2(b))
 Next
End If
Wait 1


Cls

'*******************            petla gwna              *********************

Do
   1wreset
   1wwrite &H55
   1wverify Dsid1(1)                                        'wysyamy adres pierwszego czujnika
   1wwrite &HBE
   I1 = 1wread(2)
'---------------------------------
   1wreset
   1wwrite &H55
   1wverify Dsid2(1)                                        'wysylam adres drugiego czujnika
   1wwrite &HBE                                             '
   I2 = 1wread(2)
'---------------------------------

'--------konwersja temp dla wszystkich dsow
   1wreset
   1wwrite &HCC
   1wwrite &H44



'-------------------------------

   I1 = I1 * 10
   I1 = I1 / 16
   'If I1 > 0 Then Cls                                       'korekta przesuniecia znaku st C przy przejciu z temp ujemnej na dodatni
   Ss = Str(i1)
   Ss = Format(ss , " 0.0")
   Locate 1 , 1                                             'Pozycja wywietlania nazwy i temperatury (1.1 -> 1 linia 1 kolumna, 2.10 -> 2 linia 10 kolumna itd)
   Lcd "Wy: " ; Ss ;

   I2 = I2 * 10
   I2 = I2 / 16
   'If I2 > 0 Then Cls
   Ss = Str(i2)
   Ss = Format(ss , " 0.0")
   Locate 2 , 1
   Lcd "Pa: " ; Ss ;
'----------------------------------------------------obliczanie rnicy wartoci czujnikw 1 i 2 i wywietlanie jej

   If I1 > I2 Then                                          ' obliczanie rnicy midzy czujnikiem 1 i 2 pod warunkiem e warto czujnika 1 bdzie wysza od 2,  jeli nie to R=0
    R = I1 - I2                                             'jeeli tak jest to obliczenie rnicy i przypisanie do zmiennej R
     Else
    R = 0
   End If


   Locate 1 , 12                                            'ustawiamy pozycje kursora linia i pozycja
   Lcd "*   "
   Locate 1 , 12
   Lcd "*" ; R ;                                            'wywietlania rnicy

'--------------------------jeeli wczone Auto to.....
  If Cc = 4 Then

   If R < 20 Then                                           'wczanie 1 biegu gdy rnica = R
      A = 0
      Portb.2 = 0                                           'zapalania ledw danych biegw
      Portb.3 = 0
      Portb.4 = 0
    End If

    If R > 28 Then                                          'wczanie 1 biegu gdy rnica = R
      A = 1
      Portb.2 = 1                                           'zapalania ledw danych biegw
      Portb.3 = 0
      Portb.4 = 0
    End If

    If R > 160 Then                                         'wczanie 2 biegu gdy rnica = R
      A = 2
      Portb.2 = 1                                           'zapalanie ledw danych biegw
      Portb.3 = 1
      Portb.4 = 0
    End If

    If R > 220 Then                                         'wczanie 3 biegu gdy rnica = R
      A = 3
      Portb.2 = 1                                           'zapalanie ledw danych biegw
      Portb.3 = 1
      Portb.4 = 1
    End If
   Else

  End If
'------------------------------program przyciskw
 Waitms 50

 '-----------------------------------------przycisk Auto
  If Pinc.3 = 0 Then                                        '??????wstaw waciwy port swicha
     Waitms 200
     E = 0                                                  'zerowanie zmiennej do cyklicznego powtarzania komendy sterujcej
     Cc = Cc + 4                                            'zmienna do okrelenia stanu "Auto"

     If Cc = 4 Then
       Portb.5 = 1                                          '????????????wstaw port leda auto?????????????????????
     End If

     If Cc => 8 Then
       Cc = 0
       Portb.5 = 0                                          '?????????????wstaw port leda auto????????????????
     End If
  End If

 '-----------------------------------------przycisk biegw +
  If Pinc.2 = 0 Then
      Waitms 200

      Cc = 0                                                'wyczenie Auto
      Portb.5 = 0                                           'wyczenie led Auto
      E = 0                                                 'zerowanie zmiennej do cyklicznego powtarzania komendy sterujcej
      A = A + 1                                             'zmienna bieg

     If A = 1 Then

      Portb.2 = 1
      Portb.3 = 0
      Portb.4 = 0
    End If

    If A = 2 Then

      Portb.2 = 1
      Portb.3 = 1
      Portb.4 = 0
    End If


    If A = 3 Then

      Portb.2 = 1
      Portb.3 = 1
      Portb.4 = 1
    End If

    If A = 4 Then
      A = 0
      Portb.2 = 0
      Portb.3 = 0
      Portb.4 = 0
    End If

    Waitms 200
'----------------------------------------------------------wysylanie kodu komendy do sterownika przekanikw
    C = A + Bb                                              'sumowanie zmiennej "bieg" i "owietlenie" do zmiennej C

    For D = 0 To C                                          'wysyanie kodu w ptli ktr wielokrotno podaje suma zmiennej C

     Portb.0 = 0
     Waitms 20
     Portb.0 = 1
     Waitms 20

    Next

  End If


 '-----------------------------------------przycisk biegw -
  If Pinc.1 = 0 Then
      Waitms 200

      Cc = 0                                                'wyczenie Auto
      Portb.5 = 0                                           'wyczenie led Auto
      E = 0                                                 'zerowanie zmiennej do cyklicznego powtarzania komendy sterujcej
      A = A - 1                                             'zmienna bieg

     If A <= 0 Then
      A = 0
      Portb.2 = 0
      Portb.3 = 0
      Portb.4 = 0
     End If

     If A = 1 Then

      Portb.2 = 1
      Portb.3 = 0
      Portb.4 = 0
    End If

    If A = 2 Then

      Portb.2 = 1
      Portb.3 = 1
      Portb.4 = 0
    End If


    If A = 3 Then

      Portb.2 = 1
      Portb.3 = 1
      Portb.4 = 1
    End If



    Waitms 200
'----------------------------------------------------------wysylanie komendy do sterownika przekanikw
    C = A + Bb                                              'sumowanie zmiennej "bieg" i "owietlenie" i przypisanie do zmiennej C

    For D = 0 To C                                          'wysyanie kodu w ptli ktr wielokrotno podaje suma zmiennej C

     Portb.0 = 0                                            'port wysyania komendy na ukad przekanikw
     Waitms 20
     Portb.0 = 1                                            'port wysyania komendy na ukad przekanikw
     Waitms 20

    Next

  End If


'--------------------------------------- przycisk oswietlenie
  If Pinc.0 = 0 Then
   Waitms 200
   E = 0                                                    'zerowanie zmiennej do cyklicznego powtarzania komendy sterujcej
   Bb = Bb + 4                                              'zmienna do okrelenia stanu "Owietlenia"

   If Bb = 4 Then                                           '"ON" owietlenie
     Portd.1 = 1
   End If

   If Bb => 8 Then                                          '"off" owietlenie
     Bb = 0
     Portd.1 = 0
   End If

   Waitms 200

   C = A + Bb                                               'sumowanie zmiennej "bieg" i "oswietlenie" i przypisanie do zmiennej C

   For D = 0 To C                                           'wysyanie kodu w ptli ktr wielokrotno podaje suma zmiennej C

    Portb.0 = 0                                             'port wysyania komendy na ukad przekanikw
    Waitms 20
    Portb.0 = 1                                             'port wysyania komendy na ukad przekanikw
    Waitms 20

   Next

  End If

'--------------------------------------- powtrzenie wysyania komendy po wyznaczonym czasie(ilo wykonanych ptli w sumie zmiennej E-----
E = E + 1                                                   'zmienna liczca ilo wykonanej ptli gwnej
C = A + Bb                                                  'sumowanie zmiennej "bieg" i "oswietlenie" i przypisanie do zmiennej C


 If E = 60 Then                                             'jeeli ptli gwnej wyniesie ? to wykona...

   For D = 0 To C                                           'wysyanie kodu w ptli ktr wielokrotno podaje suma zmiennej C

    Portb.0 = 0                                             ' port wysyania komendy na ukad przekanikw
    Waitms 20
    Portb.0 = 1                                             'port wysyania komendy na ukad przekanikw
    Waitms 20

   Next

   E = 0
 End If


Loop